// ChucK Example code HID/kb.ck
// slightly modified by John Ellinger for MUSC 208
Hid hi;
HidMsg msg;

// which keyboard
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// open keyboard (get device number from command line)
if( !hi.openKeyboard( device ) ) me.exit();
<<< "keyboard '" + hi.name() + "' ready", "" >>>;

// infinite event loop
while( true )
{
    // wait on event
    hi => now;

    // get one or more messages
    while( hi.recv( msg ) )
    {
        // check for action type
        if( msg.isButtonDown() )
        {
            <<< "down-which", msg.which, "down-key", msg.key, "down-ascii", msg.ascii >>>;
        }
        
        else
        {
            <<< "up-which:", msg.which, "up-key", msg.key, "up-ascii", msg.ascii >>>;
        }
    }
}
